#include "hdmi_format.h"

int hdmi::hdmi_open(int adapter, int frontend)
{
    sprintf( psz_tmp, "/dev/dvb/adapter%d/frontend%d", adapter, frontend );
    // if(fd < 3)
    fd = open(psz_tmp, O_RDWR | O_NONBLOCK);
    // qDebug("fd:%d",fd);

    hdmi_tbsecp3.setFrontend(fd);
    return fd;
}

void hdmi::hdmi_getCaptureformat(unsigned short int *InputFormat)
{

    hdmi_tbsecp3.GetCaptureFormat(InputFormat);
}

int hdmi::hdmi_softWareRST()
{
    hdmi_tbsecp3.CaptureSoftReset( );
    qDebug("software Reset, please wait several seconds...");
    for( i=0;i<100;i++)
    {

        if( hdmi_tbsecp3.read_mcu_status() == 0)
        {
            qDebug("software Reset OK!");
            break;
        }
        sleep(2);
    }
    return 0;
}

int hdmi::hdmi_mcuRST()
{
    qDebug("MCU Reset, please wait several seconds...");
    hdmi_tbsecp3.mcu_software_reset();
    for(i=0;i<100;i++)
    {
        sleep(2);
        if( hdmi_tbsecp3.read_mcu_status() == 0)
        {
            qDebug("MCU Reset OK!");
            break;
        }
    }
    return 0;
}

void hdmi::hdmi_getOutputformat(int *outsettingFormat,unsigned char *iwrNum)
{

    hdmi_tbsecp3.getoutputformat(outsettingFormat,iwrNum);
}

int hdmi::hdmi_setMute(int num)
{
    //mute output
    hdmi_tbsecp3.setMute(num);
    return 0;
}

int hdmi::hdmi_setPorgname(unsigned char *name)
{
    hdmi_tbsecp3.setprogname(name);
    return 0;
}

int hdmi::hdmi_autoMode()
{
    //set to 24cxx 0x14 to 1
    tepdate[0] = 1;
    hdmi_tbsecp3.write_24cxx(0x14,1,tepdate);
    tepdate[0] = 0;
    hdmi_tbsecp3.write_24cxx(0x15,1,tepdate);
    qDebug("set output format to auto mode(the same with input format)");
    hdmi_tbsecp3.SetCaptureFormat(1,0);
    return 0;
}

int hdmi::hdmi_manualMode(int manualNum)
{
    //set to 24cxx 0x14 to 0 and 0x15 to num
    tepdate[0] = 0;
    hdmi_tbsecp3.write_24cxx(0x14,1,tepdate);
    tepdate[0] = manualNum;
    hdmi_tbsecp3.write_24cxx(0x15,1,tepdate);
    qDebug("set output format to manual mode:");
    hdmi_tbsecp3.SetCaptureFormat(0,manualNum);
    return 0;
}

int hdmi::hdmi_advancedMode(advice_number ad)
{
    //set to 24cxx 0x14 to 0 and 0x15 to 0
    tepdate[0] = 0;
    hdmi_tbsecp3.write_24cxx(0x14,1,tepdate);
    hdmi_tbsecp3.write_24cxx(0x15,1,tepdate);

    qDebug("set output format to advanced: %d,%d,%d,%d,%d,%d",ad.profileNum,ad.levelNum,ad.H_Num,ad.V_Num,ad.bitrateNum,ad.frameNum);
    hdmi_tbsecp3.advanced_setting(ad);
    return 0;
}

int hdmi::hdmi_close(int fd)
{
    close(fd);
    return 0;
}
