
#include "tbsecp3-spi.h"
void tbsecp3::setFrontend(int f)
{
    frontend = f;
   // qDebug("fd:%d",frontend);
}

unsigned char tbsecp3::spi_CheckFree(unsigned char OpbyteNum)
{
    unsigned char tmpbuf[4];
    int i;
    int j=500;
    if(OpbyteNum==2)
        j=400;
    else if(OpbyteNum==1)
        j=200;
    //usleep(1);
    tmpbuf[0] = 0;
    for(i=0;(i<j) && (tmpbuf[0] != 1);i++)
    {
        //*(u32 *)tmpbuf = tbs_read(GPIO_BASEADDRESS , SPI_STATUS );
        *(u32 *)tmpbuf=tbs_read(SPI_STATUS);

    }
    //return (tmpbuf[0] == 1);

    if(tmpbuf[0] == 1)
        return true;
    else
    {
       // qDebug("----------spi flash check error! %x, %x, %x, %x",tmpbuf[0], tmpbuf[1],tmpbuf[2],tmpbuf[3]);
        return false;
    }
}

void tbsecp3::spi_WriteEnable()
{
    unsigned char tmpbuf[4];

    //write enable:
    tmpbuf[0] = 0x06;
    tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);
    tmpbuf[0] = 0xe0;
    tmpbuf[1] = 0x10;
    tbs_write( SPI_CONFIG  , *(u32 *)&tmpbuf[0]);
    if(spi_CheckFree(1)== false)
    {
      //  qDebug(" spi_WriteEnable error!");
        return;
    }

    return;
}


void tbsecp3::spi_WriteDisable()
{
    unsigned char tmpbuf[4];

    //write disable:
    tmpbuf[0] = 0x04;
    tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);

    tmpbuf[0] = 0xe0;
    tmpbuf[1] = 0x10;
    tbs_write( SPI_CONFIG , *(u32 *)&tmpbuf[0]);

    //spi_CheckFree(1);
    if(spi_CheckFree(1)== false)
    {
      //  printf(" spi_WriteDisable error!\n");
        return;
    }

    return;
}


unsigned char tbsecp3::spi_GetFlashID(unsigned char *flashID)
{
    unsigned char i;
    unsigned char tmpbuf[4]={0};

    tmpbuf[0] = 1; //active spi bus from "z"
    tbs_write( SPI_ENABLE , *(u32 *)&tmpbuf[0]);

    //release from Deep Power-down mode:
    tmpbuf[0] = 0xab;
    tbs_write( SPI_COMMAND  , *(u32 *)&tmpbuf[0]);
    tmpbuf[0] = 0xe0;
    tmpbuf[1] = 0x10;
    tbs_write( SPI_CONFIG , *(u32 *)&tmpbuf[0]);
    //spi_CheckFree(1);
    if(spi_CheckFree(1)== false)
    {
      //  printf(" spi_GetFlashID error 00 !\n");
        return 0;
    }


    tmpbuf[0] = 0x9f;  //write one byte "read identification command" ;
    tbs_write( SPI_COMMAND ,*(u32 *)&tmpbuf[0]);


    tmpbuf[0] = 0x80;	//cs high to low;
    tmpbuf[0] += 0x40;  //cs low to high;
    tmpbuf[0] += 0x20;  //write command;
    tmpbuf[0] += 0x10;  // read 3 bytes ID

    tmpbuf[1] = 0x10;   //just one byte command for writing;
    tmpbuf[1] += 0x03;   //read 3 bytes ID;
    tbs_write( SPI_CONFIG ,*(u32 *)&tmpbuf[0]);

    if(spi_CheckFree(1)== false)
    {
        printf(" spi read ID error!\n");
        return 0;
    }
    *(u32 *)tmpbuf = tbs_read(SPI_RD_DATA);
    for(i=0;i<3;i++)
    {
        flashID[i] = tmpbuf[i];
        //printf("ID:0x%x\n",tmpbuf[i]);
    }

// 20170110 add
    *(u32 *)tmpbuf = tbs_read( GPIO_VERSION);
    for(i=0;i<4;i++)
    {
        flashID[i+3] = tmpbuf[i];
        printf("version:0x%x\n",tmpbuf[i]);
    }
    //check flash id
    if((flashID[0]==0xc2)&&(flashID[1]==0x20)&&(flashID[2]==0x16))
        return 1;
    else if((flashID[0]==0xef)&&(flashID[1]==0x40)&&(flashID[2]==0x16))
        return 1;
    else
        return 0;
}



unsigned char tbsecp3::spi_ChipErase()
{
    unsigned char i, wip, tmpbuf[4];

    spi_WriteEnable();

    //Chip Erase:
    tmpbuf[0] = 0xc7;
    tbs_write( SPI_COMMAND  , *(u32 *)&tmpbuf[0]);
    tmpbuf[0] = 0xe0;
    tmpbuf[1] = 0x10;
    tbs_write( SPI_CONFIG  , *(u32 *)&tmpbuf[0]);
    usleep(1000);

    return 1;
}

unsigned char tbsecp3::spi_ChipEraseStatus()
{
    unsigned char wip, tmpbuf[4];

    //read status register for WIP bit;
    tmpbuf[0] = 0x05;
    tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);
    tmpbuf[0] = 0xf0;
    tmpbuf[1] = 0x11;
    tbs_write( SPI_CONFIG , *(u32 *)&tmpbuf[0]);
    usleep(2000);

    *(u32 *)tmpbuf = tbs_read(SPI_RD_DATA );
    printf("read status register: %x\n",tmpbuf[0]);
    wip = tmpbuf[0]&1;

    if(wip==0)
        return 1;
    else
        return 0;
}


bool tbsecp3::spi_read32bit(unsigned char * addr24bit, u32 *data32bit)
{
    unsigned char i, tmpbuf[4];

    tmpbuf[0] = 0x03;  // read command ;
    tmpbuf[1] = addr24bit[0]; //read_address, msb first;
    tmpbuf[2] = addr24bit[1];
    tmpbuf[3] = addr24bit[2];
    tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);

    tmpbuf[0] = 0xf0;	//cs low,cs high, write, read;
    tmpbuf[1] = 0x40;	// 4 bytes command for writing;
    tmpbuf[1] += 0x04;	 //read 4 bytes data;
    tbs_write(  SPI_CONFIG  , *(u32 *)&tmpbuf[0]);

    if(spi_CheckFree(2)== false)
    {
     //   qDebug(" spi_read32bit error!");
        return false;
    }

    *data32bit = tbs_read( SPI_RD_DATA );

    return true;
}

bool tbsecp3::spi_read1page(unsigned char * addr24bit, unsigned char *data256bytes)
{
    unsigned char i, tmpbuf[4];
    u32 addressTemp =*(u32 *)addr24bit;

    for(i=0;i<64;i++)
    {

        *(u32 *)addr24bit = addressTemp + i*4;

        tmpbuf[0] = 0x03;  // read command ;
        tmpbuf[1] = addr24bit[0]; //read_address, msb first;
        tmpbuf[2] = addr24bit[1];
        tmpbuf[3] = addr24bit[2];
        tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);

        tmpbuf[0] = 0xf0;	//cs low,cs high, write, read;
        tmpbuf[1] = 0x40;	// 4 bytes command for writing;
        tmpbuf[1] += 0x04;	 //read 4 bytes data;
        tbs_write( SPI_CONFIG , *(u32 *)&tmpbuf[0]);

    if(spi_CheckFree(2)== false)
    {
       // qDebug(" spi_read32bit error!");
        return false;
    }

    *(u32*)&data256bytes[i*4] = tbs_read( SPI_RD_DATA);

   // qDebug(" spi_read1page addr: %x\n  ( %6x)", *(u32 *)addr24bit,*(u32*)&data256bytes[i*4]);




    usleep(1000);


    }
    return true;
}


bool tbsecp3::spi_Write32bit(unsigned char * addr24bit, u32 *data32bit)
{
    unsigned char i, wip, tmpbuf[4];

    tmpbuf[0] = 0x02;  // PP;
    tmpbuf[1] = addr24bit[0]; //read_address, msb first;
    tmpbuf[2] = addr24bit[1];
    tmpbuf[3] = addr24bit[2];
    tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);

    tbs_write( SPI_WT_DATA  , *data32bit);

    tmpbuf[0] = 0xe0;	//cs low,cs high, write, no read;
    tmpbuf[1] = 0x80;	// 4 bytes command & 2 bytes data for writing;
    tbs_write( SPI_CONFIG, *(u32 *)&tmpbuf[0]);
    if(spi_CheckFree(2)== false)
    {
      //  qDebug(" spi_Write32bit 1 error!");
        return false;
    }

    //read status register for WIP bit;
    wip = 1;
    for(i=0;(i<50)&wip;i++)
    {
        usleep(1000);  //delay one second;

        tmpbuf[0] = 0x05;
        tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);
        tmpbuf[0] = 0xf0;
        tmpbuf[1] = 0x11;
        tbs_write( SPI_CONFIG  , *(u32 *)&tmpbuf[0]);
        if(spi_CheckFree(1)== false)
        {
       //     qDebug(" spi_Write32bit 2 error!");
            return false;
        }
        *(u32 *)tmpbuf = tbs_read(  SPI_RD_DATA );

        wip = tmpbuf[0]&1;
    }
    if(i==50)
        qDebug("write 16 bit-------------------------------------------------------- register: %x",tmpbuf[0]);
    return true;
}


bool tbsecp3::spi_Write1page(unsigned char * addr24bit, unsigned char *data256byte)
{
    unsigned char i,j, wip, tmpbuf[8];

    spi_WriteEnable();

    tmpbuf[0] = 0x02;  // PP;
    tmpbuf[1] = addr24bit[0]; //read_address, msb first;
    tmpbuf[2] = addr24bit[1];
    tmpbuf[3] = addr24bit[2];
    tbs_write(  SPI_COMMAND, *(u32 *)&tmpbuf[0]);
    tbs_write( SPI_WT_DATA  , *(u32 *)&data256byte[0]);

    tmpbuf[0] = 0xa0;	//cs low,cs high, write, no read;
    tmpbuf[1] = 0x80;	// 4 bytes command & 2 bytes data for writing;
    tbs_write(  SPI_CONFIG  , *(u32 *)&tmpbuf[0]);
    if(spi_CheckFree(2)== false)
    {
     //   qDebug(" spi_Write32bit 1 error!");
        return false;
    }

    for(j=0;j<31;j++)
    {
        tmpbuf[0] = data256byte[4+j*8 +0];
        tmpbuf[1] = data256byte[4+j*8 +1];
        tmpbuf[2] = data256byte[4+j*8 +2];
        tmpbuf[3] = data256byte[4+j*8 +3];
        tmpbuf[4] = data256byte[4+j*8 +4];
        tmpbuf[5] = data256byte[4+j*8 +5];
        tmpbuf[6] = data256byte[4+j*8 +6];
        tmpbuf[7] = data256byte[4+j*8 +7];

        tbs_write( SPI_COMMAND , *(u32 *)&tmpbuf[0]);
        tbs_write( SPI_WT_DATA , *(u32 *)&tmpbuf[4]);

        tmpbuf[0] = 0x20;	//cs low,cs high, write, no read;
        tmpbuf[1] = 0x80;	// 4 bytes command & 2 bytes data for writing;
        tbs_write( SPI_CONFIG , *(u32 *)&tmpbuf[0]);
        if(spi_CheckFree(2)== false)
        {
        //    qDebug(" spi_Write32bit 1 error!");
            return false;
        }
    }


    tmpbuf[0] = data256byte[252];
    tmpbuf[1] = data256byte[253];
    tmpbuf[2] = data256byte[254];
    tmpbuf[3] = data256byte[255];
    tbs_write( SPI_COMMAND, *(u32 *)&tmpbuf[0]);

    tmpbuf[0] = 0x60;	//cs low,cs high, write, no read;
    tmpbuf[1] = 0x40;	// 4 bytes command & 2 bytes data for writing;
    tbs_write( SPI_CONFIG, *(u32 *)&tmpbuf[0]);
    if(spi_CheckFree(2)== false)
    {
      //  qDebug(" spi_Write32bit 1 error!");
        return false;
    }

    //read status register for WIP bit;
    wip = 1;
    for(i=0;(i<250)&wip;i++)
    {
        //pauseThread(1);  //delay one second;

        tmpbuf[0] = 0x05;
        tbs_write(  SPI_COMMAND , *(u32 *)&tmpbuf[0]);
        tmpbuf[0] = 0xf0;
        tmpbuf[1] = 0x11;
        tbs_write(  SPI_CONFIG , *(u32 *)&tmpbuf[0]);
        if(spi_CheckFree(1)== false)
        {
        //    qDebug(" spi_Write32bit 2 error!");
            return false;
        }
        *(u32 *)tmpbuf = tbs_read( SPI_RD_DATA ) ;

        wip = tmpbuf[0]&1;
    }
    if(i==250)
    {
        //qDebug("write 16 bit-------------------------------------------------------- register: %x",tmpbuf[0]);
        return false;
    }
    return true;


}

void tbsecp3::spi_EnterDeepPowerDown()
{
    unsigned char tmpbuf[4];

    //enter  Deep Power-down mode:
    tmpbuf[0] = 0xb9;
    tbs_write (SPI_COMMAND , *(u32 *)&tmpbuf[0]);
    tmpbuf[0] = 0xe0;
    tmpbuf[1] = 0x10;
    tbs_write (SPI_CONFIG , *(u32 *)&tmpbuf[0]);
    //spi_CheckFree(1);
    if(spi_CheckFree(1)== false)
    {
      //  qDebug(" spi_EnterDeepPowerDown error!");
        return ;
    }

    tmpbuf[0] = 0; //spi disable, enter "z" state;
    tbs_write(SPI_ENABLE, *(u32 *)&tmpbuf[0]);
    return;
}

void tbsecp3::CaptureSoftReset( )
{
    unsigned char tmpbuf[4];
    tmpbuf[0]= 1;
    tmpbuf[1]= 0;
    tmpbuf[3]= 0;
    tmpbuf[2]= 0;
    tbs_write (HDMI_RST , *(u32 *)&tmpbuf[0]);

    usleep(15000);
    tmpbuf[0]= 0;
    tbs_write (HDMI_RST , *(u32 *)&tmpbuf[0]);
}

// pInputFormat[0]:VRow, pInputFormat[1]:VColumn, pInputFormat[2]:VFreq, pInputFormat[3]:VScan
void tbsecp3::GetCaptureFormat(unsigned short * pInputFormat)
{
   // int fd = open("/dev/dvb/adapter0/frontend0", O_RDWR | O_NONBLOCK);
   // qDebug("fd:%d",fd);
    unsigned char tmpbuf[4];
    unsigned short VRow, VColumn;
    unsigned short VFreq;
    unsigned short VScan;

    *(u32 *)tmpbuf = tbs_read(  HDMI_HYNC_VYNC);
    VColumn = (tmpbuf[2]<<8) + tmpbuf[3];
    VRow = (tmpbuf[0]<<8) + tmpbuf[1];

   // qDebug(" read 0x48: %2x %2x %2x %2x VRow: %d, VColumn: %d ", tmpbuf[3],tmpbuf[2],tmpbuf[1],tmpbuf[0],VRow,VColumn);

    *(u32 *)tmpbuf = tbs_read(  HDMI_SCAN_FREQ );

    VFreq = tmpbuf[0];
    VScan = tmpbuf[1]&0x1 ;

    //qDebug("read 0x4c: %2x %2x %2x %2x VFreq: %d, VScan: %d ", tmpbuf[3],tmpbuf[2],tmpbuf[1],tmpbuf[0],VFreq,VScan);
    if(VFreq>=57 && VFreq <=60)
        VFreq = 60;
    if(VFreq>=48 && VFreq <=50)
        VFreq = 50;
    if(VFreq == 23)
        VFreq = 24;
    pInputFormat[0] = VRow;
    pInputFormat[1] = VColumn;
    pInputFormat[2] = VFreq;
    pInputFormat[3] = VScan;

    qDebug("input format:\nVRow= %d, VColumn= %d, VFreq= %d, VScan= %d",pInputFormat[0],pInputFormat[1],pInputFormat[2],pInputFormat[3]);//show version number
    return;
}


// autoMode: 0 or 1, manualModeNum:manual mode (1---7)or advanced(0),
void tbsecp3::SetCaptureFormat(unsigned char autoMode,unsigned char manualModeNum )
{

    unsigned char tmpbuf[4];
    if(autoMode == 1)
    {
        //printf(" set CaptureFormat Auto Mode !\n");
        tmpbuf[0]= 1;
        tmpbuf[1]= 0;
        tmpbuf[2]= 0;
        tmpbuf[3]= 0;
        tbs_write (HDMI_AUTO_MODE , *(u32 *)&tmpbuf[0]);
    }
    else
    {

        tmpbuf[0]= 0;
        tmpbuf[1]= 0;
        tmpbuf[2]= 0;
        tmpbuf[3]= 0;
        tbs_write (HDMI_AUTO_MODE , *(u32 *)&tmpbuf[0]);

        tmpbuf[0]= manualModeNum; // BIT 24, manual mode (1---7)or advanced(0),
        tmpbuf[1]= 0;
        tmpbuf[2]= 0;
        tmpbuf[3]= 0;
        tbs_write (HDMI_SCAN_FREQ , *(u32 *)&tmpbuf[0]);
    //	printf("-M : manual (1--7,1:super 1920*1080,2:ultra 1440*1080,3:excellent 1280*720,4:good 1120*720,5:fair 960*540,6:poor 800*480,7 480*272)\n");
        switch(manualModeNum)
        {
            case 1:
                qDebug("super 1920*1080 ");
            break;
            case 2:
                qDebug("ultra 1440*1080 ");
            break;
            case 3:
                qDebug("excellent 1280*720 ");
            break;
            case 4:
                qDebug("good 1120*640 ");
            break;
            case 5:
                qDebug("fair 960*540 ");
            break;
            case 6:
                qDebug("poor 800*480 ");
            break;
            case 7:
                qDebug("mobile 480*272 ");
            break;
            default:
                qDebug(" manual (1--7,1:super 1920*1080,2:ultra 1440*1080,3:excellent 1280*720,4:good 1120*640,5:fair 960*540,6:poor 800*480,7: mobile 480*272)");
            break;

        }

    }
    worksetreset();
    return;
}


void tbsecp3::check_mcuWorkOK()
{
    unsigned char tmpbuf[4]={0};
    int i =0;

    //wait... until the data are received correctly;
    for(i=0;i<1000;i++)
    {
        usleep(1000);
        *(u32 *)tmpbuf = tbs_24cxx_rd(  STATUS_MAC16_24CXX);
        if((tmpbuf[0]&1) == 0)
            break;
    }
    //printf(" wait wt_24cxx_done  times: %d\n\r",i);
    if(i==1000)
    {
        qDebug(" the receiver always busy !");
//for test
if(read_mcu_status() == 1)
    qDebug("MC U status is busy!!!" );

        // release cs;
        tbs_24cxx_wr(  CS_RELEASE, *(u32 *)&tmpbuf[0]);
        return;
    }
    // release cs;
    tbs_24cxx_wr(  CS_RELEASE, *(u32 *)&tmpbuf[0] );
    //check the write finished;
    for(i=0;i<1000;i++)
    {
        usleep(1000);
        *(u32 *)tmpbuf = tbs_24cxx_rd(  STATUS_MAC16_24CXX);
        if((tmpbuf[0]&1) == 1)
            break;
    }
    //printf(" wait wt_24cxx_done timeout!  times: %d\n\r",i);
    if(i==1000)
        qDebug(" wait wt_24cxx_done timeout! ");

}


void tbsecp3::mcu_software_reset( )
{
    unsigned char tmpbuf[4];

    //write command:
    tmpbuf[0] = 0x03; //mcu software_reset;
    tmpbuf[1] = 0;  //num don't care
    tmpbuf[2] = 0;
    tmpbuf[3] = 0; //mcu address;

    tbs_24cxx_wr(  CMD_24CXX, *(u32 *)&tmpbuf[0] );

    check_mcuWorkOK();

    return;
}

void tbsecp3::erase_mcu( unsigned int sectorAddr )
{
    unsigned char tmpbuf[4];

    //write command:
    tmpbuf[0] = 0x00; //mcu erase;
    tmpbuf[1] = 0;  //num don't care
    tmpbuf[2] = (sectorAddr & 0xff00)>>8;
    tmpbuf[3] = (sectorAddr & 0xff); //mcu address;

    tbs_24cxx_wr( CMD_24CXX, *(u32 *)&tmpbuf[0] );
    check_mcuWorkOK();

    return;
}

// write 8 byte every time to mcu
void tbsecp3::write_mcu( unsigned int subAddr, unsigned char *wtbuffer)
{
    unsigned char tmpbuf[4];

    //prepare data;
    tbs_24cxx_wr(  DATA0_24CXX, *(u32 *)&wtbuffer[0] );
    tbs_24cxx_wr(  DATA1_24CXX, *(u32 *)&wtbuffer[4]);
    //write command:
    tmpbuf[0] = 0x02; // mcu write;
    tmpbuf[1] = 0x08;  //cmd num
    tmpbuf[2] = (subAddr & 0xff00)>>8;
    tmpbuf[3] =(subAddr & 0xff); //mcu address;

    tbs_24cxx_wr(  CMD_24CXX, *(u32 *)&tmpbuf[0] );
    check_mcuWorkOK();


    return;
}

void tbsecp3::read_mcu( unsigned int subAddr, unsigned char *rdbuffer)
{
    unsigned char tmpbuf[4];

    tmpbuf[0] = 0x01; //mcu read;
    tmpbuf[1] = 8;  //how many byte;
    tmpbuf[2] = (subAddr  & 0xff00)>>8;
    tmpbuf[3] = (subAddr & 0xff); //mcu address;

    tbs_24cxx_wr(  CMD_24CXX, *(u32 *)&tmpbuf[0]);
    //wait... until the data are received correctly;
    check_mcuWorkOK();

    //read back to host;
    *(u32 *)rdbuffer = tbs_24cxx_rd(  DATA0_24CXX );
    *(u32 *)&rdbuffer[4] = tbs_24cxx_rd(  DATA1_24CXX );

    return;
}

unsigned char tbsecp3::read_mcu_status(  )
{
    unsigned char tmpbuf[4];

    *(u32 *)tmpbuf = tbs_24cxx_rd(  STATUS_MAC16_24CXX );
    //qDebug("mcu read status: %d, %d,%d,%d", tmpbuf[0],tmpbuf[1],tmpbuf[2],tmpbuf[3]);
    return (tmpbuf[0]&0x4); // bit2==1 mcu busy
}
void tbsecp3::worksetreset()
{
    int i=0;
    CaptureSoftReset( );
    // check the status
    //qDebug("Format is setting, please wait...\n");
     for( i=0;i<100;i++)
    {
        sleep(2);
        if(read_mcu_status() == 0)
        {
          //  qDebug("Format is set OK!\n");
            break;
        }

    }
}
void tbsecp3::advanced_setting(advice_number a)
{
    int outsettingAddress[11];
    int outsettingFormat[11];


    outsettingAddress[0]= 0x1526; // profileLevel
    outsettingAddress[1]= 0x152c; // H
    outsettingAddress[2]= 0x152e; // V
    outsettingAddress[3]= 0x1532; // biteRate
    outsettingAddress[4]= 0x1534;
    outsettingAddress[5]= 0x1536;
    outsettingAddress[6]= 0x1538;
    outsettingAddress[7]= 0x1104;
    outsettingAddress[8]= 0x1584; // framRate
    outsettingAddress[9]= 0x1586;
    outsettingAddress[10]= 0x1588;

    if(a.profileNum == 1)
        a.levelNum += 512; // Main profile
    else
        a.levelNum += 256; // high profile

    //write data
    outsettingFormat[0] = a.levelNum;
    outsettingFormat[1] = a.H_Num;
    outsettingFormat[2] = a.V_Num;

    outsettingFormat[3] = a.bitrateNum *2.5;
    outsettingFormat[4] = a.bitrateNum *2;
    outsettingFormat[5] = a.bitrateNum ;
    outsettingFormat[6] = a.bitrateNum *0.5;
    outsettingFormat[7] = a.bitrateNum *3.5;

    outsettingFormat[8] = 0;
    outsettingFormat[9] = a.frameNum *2;
    outsettingFormat[10] =	1;

    unsigned char iwrNum[4] = {0};
    iwrNum[1] = 11;
    write_24cxx( 0x10,2, iwrNum);
    write_M23Register(11,outsettingAddress ,outsettingFormat);

    worksetreset();

}

void tbsecp3::setMute(int enable)
{
    unsigned char temdate[4] = {0};
    temdate[0] = enable;
    write_24cxx(0x16,1,temdate);
    worksetreset();


}

void tbsecp3::setprogname(unsigned char *progName)
{
    unsigned char temdate[4] = {0};
    int len =0;
    int i =0;
   // qDebug((char *)(progName));
    //get progname len
    u8 *tempName = progName;
    while(*tempName++)len++;
  //  qDebug("len:%d",len);
    temdate[0] = 0x60;
    write_24cxx(0x12,1,temdate);
    // qDebug("len11:%d",len);
    temdate[0] = len; //progname len
    write_24cxx(0x13,1,temdate);
 // qDebug("len11:%d",len);
    for( i=0;i<len; i++)
    {
        temdate[0] = *(progName+i); //progname len
        write_24cxx(0x60+i,1,temdate);
    }
    worksetreset( );

}
void tbsecp3::getoutputformat(int * outsettingFormat,unsigned char *iwrNum)
{
    //int outsettingFormat[11];

    read_24cxx( 0x14,1, iwrNum);
    if(iwrNum[0]==1) // auto or not
    {
        qDebug("the latest setting is Auto mode!");
        iwrNum[0] = 1;
        iwrNum[1] = 0;
        iwrNum[2] = 0;
        return;
    }
    read_24cxx( 0x15,1, iwrNum);
    if(iwrNum[0]!=0) // manual or not
    {
        qDebug("the latest setting is Manual mode:");
        switch(iwrNum[0])
        {
            case 1:
                qDebug("super 1920*1080");
            break;
            case 2:
                qDebug("ultra 1440*1080 ");
            break;
            case 3:
                qDebug("excellent 1280*720");
            break;
            case 4:
                qDebug("good 1120*640");
            break;
            case 5:
                qDebug("fair 960*540");
            break;
            case 6:
                qDebug("poor 800*480");
            break;
            case 7:
                qDebug("mobile 480*272");
            break;
            default:
                 qDebug("no");
            break;

        }
        iwrNum[1] =iwrNum[0];
        iwrNum[0] = 0;
        iwrNum[2] = 0;
        return;
    }

    read_24cxx( 0x10,2, iwrNum);//advanced mode setting
    if(iwrNum[1]==11)
    {

        read_M23Register(11,outsettingFormat);
        qDebug("the latest setting is Advanced mode: %d * %d %d ",outsettingFormat[1],outsettingFormat[2],outsettingFormat[9]/2);
    }
    iwrNum[2] = iwrNum[1];
    iwrNum[0] = 0;
    iwrNum[1] = 0;
    return;
}
void tbsecp3::write_M23Register( int num, int* m23_addr, int* m23_data)
{
    unsigned char tmpM23addr[4];
    unsigned char tmpM23data[4];
    int i =0;

    for(i=0;i<num;i++)
    {
        tmpM23addr[0]= (*(m23_addr+i) & 0xff00) >>8;
        tmpM23addr[1]=	*(m23_addr+i) & 0xff;
        tmpM23addr[2]= 0;
        tmpM23addr[3]= 0;


        tmpM23data[0]= (*(m23_data+i) & 0xff00) >>8;
        tmpM23data[1]= *(m23_data+i) & 0xff;
        tmpM23data[2]= 0;
        tmpM23data[3]= 0;

        //write the address of register
        write_24cxx( 0x20+i*4,2, tmpM23addr);
        //write the data of register
        write_24cxx(0x22+i*4,2, tmpM23data);

    }

    return;
}

void tbsecp3::read_M23Register( int num, int* m23_data)
{
    unsigned char tmpM23data[4];
    int i =0;

    for(i=0;i<num;i++)
    {
        //read the data from register
        read_24cxx( 0x22+i*4,2, tmpM23data);

        *(m23_data+i) = tmpM23data[1]&0xff;
        *(m23_data+i) += ((tmpM23data[0]<<8)&0xff00);
    }

    return;
}


/*
******************************************************************************
* FUNCTION NAME  : read_24cxx
*
* DESCRIPTIONS   : read data from 24cxx;
*
* ARGUMENTS      : subaddr: 24cxx sub address;
                   num: how many byte for read out;
*
* RETURNS        : rdbuffer
*
* GOLBALS USED   : none
*
* returns        : none
*
******************************************************************************
*/
void tbsecp3::read_24cxx( unsigned char subAddr,unsigned char num, unsigned char *rdbuffer)
{
    unsigned char tmpbuf[4];

    if(num==0)
    {
        qDebug(" read 24cxx parameter error! [num == 0]\n\r");
        return;
    }
    else if(num >8)
    {
        qDebug(" read 24cxx parameter error! [num >8]\n\r");
        return;
    }

    tmpbuf[0] = 0x31; //24cxx read;
    tmpbuf[1] = num;  //how many byte;
    tmpbuf[2] = 0;
    tmpbuf[3] = subAddr; //24cxx sub_address;

    tbs_24cxx_wr(  CMD_24CXX, *(u32 *)&tmpbuf[0] );
    //wait... until the data are received correctly;
    check_mcuWorkOK();

    //read back to host;
    *(u32 *)rdbuffer = tbs_24cxx_rd(  DATA0_24CXX );
    if(num >4)
        *(u32 *)&rdbuffer[4] = tbs_24cxx_rd(  DATA1_24CXX );
    return;
}

/*
******************************************************************************
* FUNCTION NAME  : write_24cxx
*
* DESCRIPTIONS   : write data to 24cxx;
*
* ARGUMENTS      : subaddr: 24cxx sub address;
                   num: how many byte for read out;
*
* RETURNS        : wtbuffer
*
* GOLBALS USED   : none
*
* returns        : none
*
******************************************************************************
*/
void tbsecp3::write_24cxx( unsigned char subAddr,unsigned char num, unsigned char *wtbuffer)
{
    unsigned char tmpbuf[4];
    int i=0;

    if(num==0)
    {
        qDebug(" write 24cxx parameter error! [num == 0]");
        return;
    }
    else if(num >8)
    {
        qDebug(" write 24cxx parameter error! [num >8]");
        return;
    }

    //prepare data;
    tbs_24cxx_wr(  DATA0_24CXX, *(u32 *)&wtbuffer[0] );
    if(num >4)
        tbs_24cxx_wr(  DATA1_24CXX, *(u32 *)&wtbuffer[4] );
    //write command:
    tmpbuf[0] = 0x30; //24cxx write;
    tmpbuf[1] = num;  //how many byte;
    tmpbuf[2] = 0;
    tmpbuf[3] = subAddr; //24cxx sub_address;

    tbs_24cxx_wr(  CMD_24CXX, *(u32 *)&tmpbuf[0] );
    //wait... until the data are received correctly;
    check_mcuWorkOK();
    *(u32 *)tmpbuf = tbs_24cxx_rd(  STATUS_MAC16_24CXX );
    if((tmpbuf[0]&2) == 2)
        qDebug(" write 24cxx parameter error!!! \n\r");

    return;
}





void tbsecp3::tbs_write(u8 address,u32 data)
{
    struct ecp3_info winfo;
    winfo.reg=address;
    winfo.data=data;
    //printf("data=0x%x\n",data);
 //   qDebug("tbs_write fd:%d",frontend);
    if( ioctl( frontend, FE_ECP3FW_WRITE, &winfo ) < 0 )
    {
        //printf("write eror %s\n ",strerror(errno));
        //exit(1);
    }

}


u32 tbsecp3::tbs_read(u8 address)
{
    struct ecp3_info rinfo;
    rinfo.reg=address;
   // qDebug("addr:%#x",rinfo.reg);
   // if( ioctl( frontend, FE_ECP3FW_READ, &rinfo ) < 0 )
    // qDebug("tbs_read fd:%d",frontend);
    if( ioctl( frontend, FE_ECP3FW_READ, &rinfo ) < 0 )
    {
         qDebug("read eror ");
        //exit(1);
    }
    //qDebug("read data=0x%x",rinfo.data);
    return rinfo.data;
}

void tbsecp3::tbs_24cxx_wr(u8 address,u32 data)
{
    struct mcu24cxx_info winfo;
    winfo.bassaddr = BASE_ADDRESS_24CXX; //0x4000
    winfo.reg=address;
    winfo.data=data;
    //printf("data=0x%x\n",data);
     //qDebug("tbs_24cxx_wr fd:%d",frontend);
    if( ioctl(frontend, FE_24CXX_WRITE, &winfo ) < 0 )
    {
        //printf("write eror %s\n ",strerror(errno));
        //exit(1);
    }

}


u32 tbsecp3::tbs_24cxx_rd(u8 address)
{
    struct mcu24cxx_info rinfo;
    rinfo.bassaddr = BASE_ADDRESS_24CXX; //0x4000
    rinfo.reg = address;
    //qDebug("tbs_24cxx_rd fd:%d",frontend);
    if( ioctl( frontend, FE_24CXX_READ, &rinfo ) < 0 )
    {
       // printf("read eror ");
        //exit(1);
    }
    //printf("read data=0x%x\n",rinfo.data);
    return rinfo.data;
}


