#ifndef TBSECP3SPI
#define TBSECP3SPI
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <stdint.h>
#include <inttypes.h>
#include <stdbool.h>
#include <string.h>
#include <ctype.h>
#include <pthread.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <getopt.h>
#include <errno.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <linux/fs.h>
#include <stdbool.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <inttypes.h>
#include <sys/ioctl.h>
#include <string.h>
#include <errno.h>
#include <QDebug>
#include <linux/dvb/frontend.h>
//#include "hdmi_format.h"
//spi flash
#define SPI_CONFIG      	 0x10
#define SPI_STATUS      	 0x10
#define SPI_COMMAND     	 0x14
#define SPI_WT_DATA     	 0x18
#define SPI_RD_DATA     	 0x1c
#define SPI_ENABLE       	 0x1c
#define GPIO_VERSION       0x20

//HDMI the folloing address( Write:User input video format, Read: true format from 6604)   very import: High and low is reversed

#define HDMI_RST  		0x44      //system reset
#define HDMI_AUTO_MODE  0x48  	  //Auto_mode (1) meaningful. System to identify video format parameters or user input video format parameters
#define HDMI_HYNC_VYNC  0x48      //bit[31:16]Hync, bit[15:0]Vync
#define HDMI_SCAN_FREQ	0x4c      //bit[31:24] Video format frequency parameters, Bit[16]: user input video format is  (0:interleave): 1:progressive) scanning
//===============================================

//-------------24cXX --------------------------------------------------------
#define BASE_ADDRESS_24CXX  	0x4000
#define CMD_24CXX	      0*4   //write only
#define DATA0_24CXX       1*4   //W/R
#define DATA1_24CXX       2*4   //W/R
#define CS_RELEASE        3*4   //write only

#define STATUS_MAC16_24CXX	 0*4   //read only
#define MAC32_24CXX	 		 3*4   //read only
//---------------------------------------------------------------------

typedef unsigned char u8;
typedef unsigned int u32;
class advice_number
{
public:
    int profileNum;
    int levelNum;
    int H_Num;
    int V_Num;
    int bitrateNum;
    int frameNum;
};
class tbsecp3
{
public:
    unsigned char spi_CheckFree(unsigned char OpbyteNum);
    void spi_WriteEnable();
    void spi_WriteDisable();
    unsigned char spi_GetFlashID(unsigned char *flashID);
    unsigned char spi_ChipErase();
    unsigned char spi_ChipEraseStatus();
    bool spi_read32bit(unsigned char * addr24bit, u32 *data32bit);
    bool spi_read1page(unsigned char * addr24bit, unsigned char *data256bytes);
    bool spi_Write32bit(unsigned char * addr24bit, u32 *data32bit);
    bool spi_Write1page(unsigned char * addr24bit, unsigned char *data256byte);
    void spi_EnterDeepPowerDown();

    void CaptureSoftReset( );
    void GetCaptureFormat(unsigned short * pInputFormat);
    void SetCaptureFormat(unsigned char autoMode,unsigned char manualModeNum );
    void check_mcuWorkOK();
    void mcu_software_reset( );
    void erase_mcu( unsigned int sectorAddr );
    void write_mcu( unsigned int subAddr, unsigned char *wtbuffer);
    void read_mcu( unsigned int subAddr, unsigned char *rdbuffer);
    unsigned char read_mcu_status(  );
    void read_24cxx( unsigned char subAddr,unsigned char num, unsigned char *rdbuffer);
    void write_24cxx( unsigned char subAddr,unsigned char num, unsigned char *wtbuffer);
    void read_M23Register( int num, int* m23_data);
    void write_M23Register( int num, int* m23_addr, int* m23_data);

    void advanced_setting(advice_number a);

    void getoutputformat(int *outsettingFormat, unsigned char *iwrNum);
    void setMute(int enable);
    void setprogname(unsigned char *progName);
    void worksetreset();
    void tbs_write(u8 address,u32 data);
    u32 tbs_read(u8 address);
    void tbs_24cxx_wr(u8 address,u32 data);
    u32 tbs_24cxx_rd(u8 address);
    void setFrontend(int f);
private:
    int frontend;
};
#endif // TBSECP3SPI

