#include "widget.h"
#include "ui_widget.h"
Widget::Widget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::Widget)
{
    ui->setupUi(this);
    this->setFixedSize( this->width (),this->height ());
    ui->statuslabel->setText(" ");
    amg.mode = 0;//0.no 1.auto 2.mual 3.advace
    amg.ma = 0;
    count = 0;
    flg = 0;
    fg = 0;
    getHardwareInfor();
    if(0 == flg ){
        //qDebug("fail");
        ui->showlabel->setText("Fail:Not an HDMI capture card");
    }else if(2 == flg){
         ui->showlabel->setText("Fail:adapter and fronted are erro");
    }else{
        fd = hd.hdmi_open(0,0);
        if(fd < 0){
          //  qDebug("Fail:adapter and fronted are mismatched");
            ui->showlabel->setText("Fail:adapter and fronted are erro");
        }else{
          //  qDebug("OK");
            ui->showlabel->setText("OK");;
        }
        init_UI();
    }
}

Widget::~Widget()
{
    if( fd > 2)
        hd.hdmi_close(fd);
    delete hdmiThread;
    delete ui;
}
void Widget::on_superButton_clicked()
{
    amg.ma = 1;
    if(0 == fg)
        ui->statuslabel->setText(" ");
}

void Widget::on_ultraButton_clicked()
{
    amg.ma = 2;
    if(0 == fg)
        ui->statuslabel->setText(" ");
}

void Widget::on_excellentButton_clicked()
{
    amg.ma = 3;
    if(0 == fg)
        ui->statuslabel->setText(" ");
}

void Widget::on_goodButton_clicked()
{
    amg.ma = 4;
    if(0 == fg)
        ui->statuslabel->setText(" ");
}

void Widget::on_fairButton_clicked()
{
    amg.ma = 5;
    if(0 == fg)
        ui->statuslabel->setText(" ");
}

void Widget::on_poorButton_clicked()
{
    amg.ma = 6;
    if(0 == fg)
        ui->statuslabel->setText(" ");
}

void Widget::on_mobileButton_clicked()
{
    amg.ma = 7;
    if(0 == fg)
        ui->statuslabel->setText(" ");
}

void Widget::init_UI()
{
    if( fd >2){
        unsigned short pInputFormat[4];
        QString RowScan;
        hd.hdmi_getCaptureformat(pInputFormat);
        if(0 == pInputFormat[3])
            RowScan = "I";
        else
            RowScan = "P";
        ui->lineInputFormat->setText(QString("%1*%2 %3HZ ").arg(pInputFormat[0]).arg(pInputFormat[1]).arg(pInputFormat[2])+RowScan);
        /*************************************************/
        int outsettingFormat[11]={0};
        unsigned char iwrNum[4] = {0};
        hd.hdmi_getOutputformat(outsettingFormat,iwrNum);
        if(iwrNum[0]==1) // auto or not
        {
            ui->linelOutputformat->setText("Auto mode!");
            ui->autoModeButton->setChecked(1);

            ui->superButton->setDisabled(1);
            ui->ultraButton->setDisabled(1);
            ui->excellentButton->setDisabled(1);
            ui->goodButton->setDisabled(1);
            ui->fairButton->setDisabled(1);
            ui->poorButton->setDisabled(1);
            ui->mobileButton->setDisabled(1);

            ui->h264profileComboBox->setDisabled(1);
            ui->h264LevelComboBox->setDisabled(1);
            ui->lineEncodedWidth->setDisabled(1);
            ui->lineEncodedHight->setDisabled(1);
            ui->lineAverageBitRate->setDisabled(1);
            ui->lineEncodingFrameRate->setDisabled(1);
            amg.mode =1;
        }
        if(iwrNum[1]!=0) // manual or not
        {
            ui->manualButton->setChecked(1);

            ui->h264profileComboBox->setDisabled(1);
            ui->h264LevelComboBox->setDisabled(1);
            ui->lineEncodedWidth->setDisabled(1);
            ui->lineEncodedHight->setDisabled(1);
            ui->lineAverageBitRate->setDisabled(1);
            ui->lineEncodingFrameRate->setDisabled(1);

            ui->superButton->setDisabled(0);
            ui->ultraButton->setDisabled(0);
            ui->excellentButton->setDisabled(0);
            ui->goodButton->setDisabled(0);
            ui->fairButton->setDisabled(0);
            ui->poorButton->setDisabled(0);
            ui->mobileButton->setDisabled(0);
            amg.mode = 2;
            switch(iwrNum[1])
            {
                case 1:
                    ui->linelOutputformat->setText(" Manual mode:super 1920*1080");
                    ui->superButton->setChecked(1);
                    amg.ma = 1;
                    break;
                case 2:
                    ui->linelOutputformat->setText("Manual mode:ultra 1440*1080 ");
                    ui->ultraButton->setChecked(1);
                    amg.ma = 2;
                    break;
                case 3:
                    ui->linelOutputformat->setText("Manual mode:excellent 1280*720");
                    ui->excellentButton->setChecked(1);
                    amg.ma = 3;
                    break;
                case 4:
                    ui->linelOutputformat->setText("Manual mode:good 1120*640");
                    ui->goodButton->setChecked(1);
                    amg.ma = 4;
                    break;
                case 5:
                    ui->linelOutputformat->setText("Manual mode:fair 960*540");
                    ui->fairButton->setChecked(1);
                    amg.ma = 5;
                    break;
                case 6:
                    ui->linelOutputformat->setText("Manual mode:poor 800*480");
                    ui->poorButton->setChecked(1);
                    amg.ma = 6;
                    break;
                case 7:
                    ui->linelOutputformat->setText("Manual mode:mobile 480*272");
                    ui->mobileButton->setChecked(1);
                    amg.ma = 7;
                    break;
                default:
                    break;
            }
        }
        if(iwrNum[2]==11)
        {
            ui->linelOutputformat->setText(QString(" Advanced mode:%1*%2 %3HZ").arg(outsettingFormat[1]).arg(outsettingFormat[2]).arg(outsettingFormat[9]/2));
            ui->advancedButton->setChecked(1);

            int level[6] = {30,31,32,40,41,42};
            ui->superButton->setDisabled(1);
            ui->ultraButton->setDisabled(1);
            ui->excellentButton->setDisabled(1);
            ui->goodButton->setDisabled(1);
            ui->fairButton->setDisabled(1);
            ui->poorButton->setDisabled(1);
            ui->mobileButton->setDisabled(1);

            ui->h264profileComboBox->setDisabled(0);
            ui->h264LevelComboBox->setDisabled(0);
            ui->lineEncodedWidth->setDisabled(0);
            ui->lineEncodedHight->setDisabled(0);
            ui->lineAverageBitRate->setDisabled(0);
            ui->lineEncodingFrameRate->setDisabled(0);
            amg.mode = 3;

            amg.ad.profileNum = ui->h264profileComboBox->currentIndex();
            amg.ad.levelNum = level[ui->h264LevelComboBox->currentIndex()];
            amg.ad.H_Num = ui->lineEncodedWidth->text().toInt();
            amg.ad.V_Num = ui->lineEncodedHight->text().toInt();
            amg.ad.bitrateNum = ui->lineAverageBitRate->text().toInt();
            amg.ad.frameNum = ui->lineEncodingFrameRate->text().toInt();
        }
    }
}

void Widget::getHardwareInfor()
{
    char b[8] = {'C','a','p','t','u','r','e','\n'};
    if((fp = fopen("log2","r")) == NULL){
        qDebug("fail to fopen");
    }
    int i = 0;
    int n = 0;
    bzero(buf,sizeof(buf));
    while((n = fread(buf,1,128,fp)) >= 0){
        if('\0' == buf[i])
            break;
       // qDebug("read buf[%d] = %c,n:%d",i,buf[i],n);
        i++;
    }
   // qDebug(&buf[2]);
    if(0 == strncmp(&buf[2],b,8)){
       // qDebug("is Capture");
        flg = 1;
    }else {
      //  qDebug("isn't Capture");
        flg = 0;
    }
    fclose(fp);
}

bool Widget::is_capture()
{
    int i = 0;
    char b[8] = {'C','a','p','t','u','r','e','\n'};
    while(i < strlen(buf))
    {
        if(((buf[i] -48) == ui->lineAdapter->text().toInt()) &&((buf[i+1]-48) == ui->lineFrontend->text().toInt())){
           // qDebug(&buf[i+2]);
            if(0 == strncmp(&buf[i+2],b,8)){
             //   qDebug("is Capture");
                return 1;
            }else {
              //  qDebug("isn't Capture");
                return 0;
            }

            break;
        }
        i++;
    }
    if(i == strlen(buf)){
        return 2;
    }
   // qDebug("no Capture");
    return 2 ;
}

void Widget::showText()
{
    ui->statuslabel->setText("Configuration has been completed!");
    if(fd < 3)
        fd = hd.hdmi_open(ui->lineAdapter->text().toInt(),ui->lineFrontend->text().toInt());
    if(fd < 0){
      //  qDebug("Fail:adapter and fronted are erro");
        ui->showlabel->setText("Fail:adapter and fronted are erro");
    }else{
       // qDebug("OK");
        ui->showlabel->setText("OK");;
    }
    count = 0;
    fg = 0;

}

void Widget::on_checkAFButton_clicked()
{
    if(0 == fg){
        ui->statuslabel->setText(" ");
        ::close(fd);
        if(0 == is_capture()){
           // qDebug("fail");
            ui->showlabel->setText("Fail:Not an HDMI capture card");
        }else if(2 == is_capture()){
            ui->showlabel->setText("Fail:adapter and fronted are erro");
        }else{
            fd = hd.hdmi_open(ui->lineAdapter->text().toInt(),ui->lineFrontend->text().toInt());
            if(fd < 0){
              //  qDebug("fail");
                ui->showlabel->setText("Fail:adapter and fronted are erro");
            }else{
               // qDebug("ok");
                ui->showlabel->setText("OK");;
            }
        }
    }
}

void Widget::on_getInputButton_clicked()
{
    if(0 == fg)
        ui->statuslabel->setText(" ");
    if( fd >2){
        unsigned short pInputFormat[4];
        QString RowScan;
        hd.hdmi_getCaptureformat(pInputFormat);
        if(0 == pInputFormat[3])
            RowScan = "I";
        else
            RowScan = "P";
        ui->lineInputFormat->setText(QString("%1*%2 %3HZ ").arg(pInputFormat[0]).arg(pInputFormat[1]).arg(pInputFormat[2])+RowScan);
    }

}

void Widget::on_getOutputButton_clicked()
{
    if(0 == fg)
        ui->statuslabel->setText(" ");
    if( fd >2){
        int outsettingFormat[11]={0};
        unsigned char iwrNum[4] = {0};
        hd.hdmi_getOutputformat(outsettingFormat,iwrNum);
        if(iwrNum[0]==1) // auto or not
        {
            ui->linelOutputformat->setText("Auto mode!");
            return;
        }
        if(iwrNum[1]!=0) // manual or not
        {
            switch(iwrNum[1])
            {
                case 1:
                    ui->linelOutputformat->setText(" Manual mode:super 1920*1080");
                    break;
                case 2:
                    ui->linelOutputformat->setText("Manual mode:ultra 1440*1080 ");
                    break;
                case 3:
                    ui->linelOutputformat->setText("Manual mode:excellent 1280*720");
                    break;
                case 4:
                    ui->linelOutputformat->setText("Manual mode:good 1120*640");
                    break;
                case 5:
                    ui->linelOutputformat->setText("Manual mode:fair 960*540");
                    break;
                case 6:
                    ui->linelOutputformat->setText("Manual mode:poor 800*480");
                    break;
                case 7:
                    ui->linelOutputformat->setText("Manual mode:mobile 480*272");
                    break;
                default:
                    break;
            }
            return;
        }
        if(iwrNum[2]==11)
        {
            ui->linelOutputformat->setText(QString(" Advanced mode:%1*%2 %3HZ").arg(outsettingFormat[1]).arg(outsettingFormat[2]).arg(outsettingFormat[9]/2));
            return;
        }
    }


}

void Widget::on_autoModeButton_clicked()
{
    if(0 == fg)
        ui->statuslabel->setText(" ");
    ui->superButton->setDisabled(1);
    ui->ultraButton->setDisabled(1);
    ui->excellentButton->setDisabled(1);
    ui->goodButton->setDisabled(1);
    ui->fairButton->setDisabled(1);
    ui->poorButton->setDisabled(1);
    ui->mobileButton->setDisabled(1);

    ui->h264profileComboBox->setDisabled(1);
    ui->h264LevelComboBox->setDisabled(1);
    ui->lineEncodedWidth->setDisabled(1);
    ui->lineEncodedHight->setDisabled(1);
    ui->lineAverageBitRate->setDisabled(1);
    ui->lineEncodingFrameRate->setDisabled(1);
    if( fd >2){
        amg.mode =1;
    }

}



void Widget::on_manualButton_clicked()
{
    if(0 == fg)
        ui->statuslabel->setText(" ");
    ui->superButton->setDisabled(0);
    ui->ultraButton->setDisabled(0);
    ui->excellentButton->setDisabled(0);
    ui->goodButton->setDisabled(0);
    ui->fairButton->setDisabled(0);
    ui->poorButton->setDisabled(0);
    ui->mobileButton->setDisabled(0);

    ui->h264profileComboBox->setDisabled(1);
    ui->h264LevelComboBox->setDisabled(1);
    ui->lineEncodedWidth->setDisabled(1);
    ui->lineEncodedHight->setDisabled(1);
    ui->lineAverageBitRate->setDisabled(1);
    ui->lineEncodingFrameRate->setDisabled(1);
    if( fd >2){
        amg.mode = 2;
    }

}

void Widget::on_advancedButton_clicked()
{
    if(0 == fg)
        ui->statuslabel->setText(" ");
    int level[6] = {30,31,32,40,41,42};
    ui->superButton->setDisabled(1);
    ui->ultraButton->setDisabled(1);
    ui->excellentButton->setDisabled(1);
    ui->goodButton->setDisabled(1);
    ui->fairButton->setDisabled(1);
    ui->poorButton->setDisabled(1);
    ui->mobileButton->setDisabled(1);

    ui->h264profileComboBox->setDisabled(0);
    ui->h264LevelComboBox->setDisabled(0);
    ui->lineEncodedWidth->setDisabled(0);
    ui->lineEncodedHight->setDisabled(0);
    ui->lineAverageBitRate->setDisabled(0);
    ui->lineEncodingFrameRate->setDisabled(0);
    if( fd >2){
        amg.mode = 3;
        amg.ad.profileNum = ui->h264profileComboBox->currentIndex();
        amg.ad.levelNum = level[ui->h264LevelComboBox->currentIndex()];
        amg.ad.H_Num = ui->lineEncodedWidth->text().toInt();
        amg.ad.V_Num = ui->lineEncodedHight->text().toInt();
        amg.ad.bitrateNum = ui->lineAverageBitRate->text().toInt();
        amg.ad.frameNum = ui->lineEncodingFrameRate->text().toInt();
    }


}

void Widget::on_muteCheckBox_clicked(bool check)
{
    if(0 == fg)
        ui->statuslabel->setText(" ");
    if( fd >2){
        amg.mf = check;
        //qDebug("mute:%d",check);
    }

}


void Widget::on_setButton_clicked()
{
    if(0 == fg)
        ui->statuslabel->setText(" ");
    if( fd >2){
        QString str = ui->lineProgamName->text();
        char *ch;
        QByteArray ba =str.toLatin1();
        ch = ba.data();
        //qDebug(ch);
        int i = 0;
        while(ch[i] != '\0'){
            amg.uc[i] =(unsigned char)(ch[i]);
            i++;
        }
        amg.uc[i]='\0';
        amg.mode = 4;
        fg= 1;
        ui->statuslabel->setText("Being configured,please wait..");
        amg.adapter = ui->lineAdapter->text().toInt();
        amg.frontend = ui->lineFrontend->text().toInt();

        //advice
        int level[6] = {30,31,32,40,41,42};
        amg.ad.profileNum = ui->h264profileComboBox->currentIndex();
        amg.ad.levelNum = level[ui->h264LevelComboBox->currentIndex()];
        amg.ad.H_Num = ui->lineEncodedWidth->text().toInt();
        amg.ad.V_Num = ui->lineEncodedHight->text().toInt();
        amg.ad.bitrateNum = ui->lineAverageBitRate->text().toInt();
        amg.ad.frameNum = ui->lineEncodingFrameRate->text().toInt();

        ::close(fd);
        fd = 0;
        hdmiThread = new hdmi_thread();
        hdmiThread->getWidgetArg(amg);
        hdmiThread->start();
        connect(hdmiThread,SIGNAL(finished()),this,SLOT(showText()));
    }

}

void Widget::on_hardwareRestButton_clicked()
{
    if(0 == fg)
        ui->statuslabel->setText(" ");
    if( fd >2){
        amg.mode = 5;
    }

}

void Widget::on_setFormatButton_clicked()
{
    count ++;
    if( fd >2 && count == 1){
        fg= 1;
        ui->statuslabel->setText("Being configured,please wait..");
        amg.adapter = ui->lineAdapter->text().toInt();
        amg.frontend = ui->lineFrontend->text().toInt();

        //advice
        int level[6] = {30,31,32,40,41,42};
        amg.ad.profileNum = ui->h264profileComboBox->currentIndex();
        amg.ad.levelNum = level[ui->h264LevelComboBox->currentIndex()];
        amg.ad.H_Num = ui->lineEncodedWidth->text().toInt();
        amg.ad.V_Num = ui->lineEncodedHight->text().toInt();
        amg.ad.bitrateNum = ui->lineAverageBitRate->text().toInt();
        amg.ad.frameNum = ui->lineEncodingFrameRate->text().toInt();

        ::close(fd);
        fd = 0;
        hdmiThread = new hdmi_thread();
        hdmiThread->getWidgetArg(amg);
        hdmiThread->start();
        connect(hdmiThread,SIGNAL(finished()),this,SLOT(showText()));
    }
}

