#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <stdint.h>
#include <inttypes.h>
#include <stdbool.h>
#include <string.h>
#include <ctype.h>
#include <pthread.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <getopt.h>
#include <errno.h>
#include <fcntl.h>  
#include <string.h>  
#include <sys/types.h>  
#include <sys/stat.h>  
#include <linux/fs.h>

#include "tbsecp3-spi.h"

const char *R_FILE_NAME = NULL;   
const char *W_FILE_NAME = NULL;  
unsigned char file_buffer[256]; 
int i_adapter = 0;
int i_fenum =0;
int i_frontend=-1;
int i_information = 0;
int i_softwareRST = 0;
int i_MCU_RST = 0;
int i_macAddress = 0;
int i_autoMode = 0;
int i_manualenable = 0;
int i_manualNum = 0;

int i_profileEN = 0;
int i_profileNum = 0;
int i_levelEN = 0;
int i_levelNum = 0;
int i_H_EN = 0;
int i_H_Num = 0;
int i_V_EN = 0;
int i_V_Num = 0;
int i_bitrateEN = 0;
int i_bitrateNum = 0;
int i_frameEN = 0;
int i_frameNum = 0; 
int i_outputEN = 0; 
int i_muteEN = 0; 
int i_muteNum = 0;
int i_prognameEN = 0;
u8 * str_progname = NULL;
static const struct option long_options[] =
{
	{ "adapter",         required_argument, NULL, 'a' },
	{ "frontend-number", required_argument, NULL, 'n' },
	{ "software reset",  no_argument, NULL, 'r' },
	{ "MCU reset",  no_argument, NULL, 'R' },
	{ "Mac address",  no_argument, NULL, 'N' },
	{ "Auto Mode to output format",  no_argument, NULL, 'A' },
	{ "manual mode to output format ",  required_argument, NULL, 'M' },
	{ "profile", 	     required_argument, NULL, 'p' },//1
	{ "level", 	     required_argument, NULL, 'l' },//2
	{ "H", 	     required_argument, NULL, 'H' },//3
	{ "V", 	     required_argument, NULL, 'V' },//4
	{ "bitrate", 	     required_argument, NULL, 'B' },//5
	{ "frame", 	     required_argument, NULL, 'F' },//6
	{ "information",     no_argument,       NULL, 'i' },
	{ "outputformat",     no_argument,       NULL, 'c' },
	{ "mute",     required_argument,       NULL, 'x' },
	{ "set prog Name",     required_argument,       NULL, 'K' },
	{ "help",            no_argument,       NULL, 'h' },
	{ 0, 0, 0, 0 }
};
  

void usage()
{
	printf("\n");	
	printf("Usage: hdmioptions:\n");
	printf("-a <adapter> -n <frontend number> \n");
	printf("-i : putout the information format of the input\n");
	printf("-r : software reset\n");
	printf("-R : MCU reset\n");
	printf("-N : Mac address \n");
	printf("\n");
	printf("\n");

	printf("-c : check the latest configuration of the output format\n");
	printf("-x : set output mute(1:mute,0:normal) when audio and video are out of sync\n");
	printf("-K <progName> : set program Name \n");
	printf("set output Format,one of the following three:\n");
	printf("\n");

	printf("Auto mode: -A (the same with input format)\n");
	printf("\n");
	printf("Manual: -M (1--7,1:super 1920*1080,2:ultra 1440*1080,3:excellent 1280*720,4:good 1120*640,5:fair 960*540,6:poor 800*480,7:mobile 480*272)\n");
	printf("\n");
	printf("Advanced: -p : profile(0:high, 1:Main) -l :level (30/31/32/40/41/42) -H(size) -V(size)(1920*1080--480*272) -B : bitRate(350--18000K) -F : frameRate : (24--60)\n");
	printf("~Output Format:\n");

	printf("\n");

	exit(1);
}     


  
int main( int i_argc, char **pp_argv )
{ 		 
	int c;
	char psz_tmp[128];
	FILE * r_file_fd;  
	FILE * w_file_fd;  
	int read_len ;
	int i=0;
	unsigned char tepdate[4]={0};	
	if(i_argc == 1)
		usage();
	while ( (c = getopt_long(i_argc, pp_argv, "a:n:rRNcx:K:AM:p:l:H:V:B:F:ih", long_options, NULL)) != -1 )     
	{
		switch ( c )
		{			
			case 'a':
			  i_adapter = strtol( optarg, NULL, 0 );
			  break;
			case 'n':
			  i_fenum = strtol( optarg, NULL, 0 );
			  break;
			case 'r':
				i_softwareRST=1;
				break;
			case 'R':
				i_MCU_RST=1;
				break;
			case 'N':
				i_macAddress=1;
				break;
			case 'c':
				i_outputEN=1;
				break;
			case 'x':
				i_muteEN=1;
				i_muteNum = strtol( optarg, NULL, 0 );
				break;
			case 'K':
				i_prognameEN=1;
				str_progname = optarg;
				break;
			case 'A':
				i_autoMode=1;
				break;
			case 'M':
				i_manualenable = 1;
				i_manualNum=strtol( optarg, NULL, 0 );
				break;
			case 'p':
				i_profileEN = 1;
				i_profileNum=strtol( optarg, NULL, 0 );
				break;
			case 'l':
				i_levelEN = 1;
				i_levelNum=strtol( optarg, NULL, 0 );
				break;
			case 'H':
				i_H_EN = 1;
				i_H_Num=strtol( optarg, NULL, 0 );
				break;
			case 'V':
				i_V_EN = 1;
				i_V_Num=strtol( optarg, NULL, 0 );
				break;
			case 'B':
				i_bitrateEN = 1;
				i_bitrateNum=strtol( optarg, NULL, 0 );
				break;
			case 'F':
				i_frameEN = 1;
				i_frameNum=strtol( optarg, NULL, 0 );
				break;
			case 'i':
				i_information=1;
				break;
			case 'h':
			default:
			usage();	
		}
	  }
	if(optind < i_argc )
			usage();		
	//printf("i_adapter=%d,i_fenum=%d\n",i_adapter,i_fenum);
	sprintf( psz_tmp, "/dev/dvb/adapter%d/frontend%d", i_adapter, i_fenum );
	if( (i_frontend = open(psz_tmp, O_RDWR | O_NONBLOCK)) < 0 )
	{
	    printf( "opening device %s failed (%s)", psz_tmp,strerror(errno) );
	    exit(1);
	}

	if(i_information == 1)
	{
		unsigned short InputFormat[4];
		GetCaptureFormat(InputFormat);
		
	}				
	if(i_softwareRST == 1)
	{
		CaptureSoftReset( );
		printf("software Reset, please wait several seconds...\n");
		for( i=0;i<100;i++)
		{
			sleep(2);
			if(read_mcu_status() == 0)
			{
				printf("software Reset OK!\n");
				break;
			}
		}
	}		
	if(i_MCU_RST == 1)
	{
		printf("MCU Reset, please wait several seconds...\n");
		mcu_software_reset();
		for(i=0;i<100;i++)
		{
			sleep(2);
			if(read_mcu_status() == 0)
			{
				printf("MCU Reset OK!\n");
				break;
			}
		}

	}
	if(i_macAddress == 1)
	{
		unsigned char rdbytes[6]={0};
		read_24cxx(0X08,6,rdbytes);
	printf("mac address: 0x%02x,0x%02x,0x%02x,0x%02x,0x%02x,0x%02x\n", rdbytes[0],rdbytes[1],rdbytes[2],rdbytes[3],rdbytes[4],rdbytes[5]);
		//unsigned char wrbytes[6]={0x0,0x22,0xab,0xf0,0xb8,0x22};
		//write_24cxx(0x08,6,wrbytes); 

	}
	if(i_outputEN == 1)
	{
		getoutputformat();
	}
	if(i_muteEN == 1)
	{
		//mute output
		setMute(i_muteNum);
	}
	if(i_prognameEN == 1)
	{
		setprogname(str_progname);
	}

	if(i_autoMode == 1)
	{
		printf("set output format to auto mode(the same with input format)\n");
		SetCaptureFormat(1,0);
		//set to 24cxx 0x14 to 1
		tepdate[0] = 1;
		write_24cxx(0x14,1,tepdate);
		tepdate[0] = 0;
		write_24cxx(0x15,1,tepdate);

	}
	else if(i_manualenable == 1)
	{
		printf("set output format to manual mode:\n");
		SetCaptureFormat(0,i_manualNum);

		//set to 24cxx 0x14 to 0 and 0x15 to num
		tepdate[0] = 0;
		write_24cxx(0x14,1,tepdate);
		tepdate[0] = i_manualNum;
		write_24cxx(0x15,1,tepdate);

	}
	else if((i_profileEN == 1)&&(i_levelEN == 1)&&(i_H_EN == 1)&&(i_V_EN == 1)&&(i_bitrateEN == 1)&&(i_frameEN == 1))
	{
		//set to 24cxx 0x14 to 0 and 0x15 to 0
		tepdate[0] = 0;
		write_24cxx(0x14,1,tepdate);
		write_24cxx(0x15,1,tepdate);

		printf("set output format to advanced: %d,%d,%d,%d,%d,%d\n",i_profileNum,i_levelNum,i_H_Num,i_V_Num,i_bitrateNum,i_frameNum);
		
		advanced_setting();
		
	}
	
	if((i_information == 0) && (i_softwareRST == 0) && (i_MCU_RST == 0)&& (i_macAddress == 0)&& (i_autoMode == 0)&& (i_manualenable == 0)&& (i_outputEN ==0)&&(i_profileEN == 0)&& (i_H_EN == 0)&&(i_prognameEN ==0)&&(i_muteEN ==0))		  		
				usage();
		 
    return 0;  
}   
